import java.awt.*;
public class Main extends Frame implements Runnable {
    Label timeDisp = new Label("  0:0  ", Label.CENTER);
    Thread timerThread;
    int time = 0;    // The time in seconds.
    Button btReset = new Button("Reset");
    Button btStart = new Button("Start");
    Button btStop = new Button("Stop");

    Main() {
        super("Button Example");
        Panel p = new Panel();

        // Use a grid layout manager for the 3 buttons.
        p.setLayout(new GridLayout(1, 0));
        btReset.disable();
        btStop.disable();
        p.add(btReset);
        p.add(btStart);
        p.add(btStop);
        add("South", p);

        // Make the time display very large.
        timeDisp.setFont(new Font("Courier", Font.BOLD, 60));
        add("Center", timeDisp);
        pack();
        show();
    }
    
    // Returns only when the timerThread has terminated.
    void stop() {
        Thread t = timerThread;
        if (t != null) {
            timerThread = null;
            try { t.join(); } catch (Exception e) {}
        }
    }

    public boolean action(Event evt, Object what) {
        if (evt.target == btReset) {
            stop();
            timeDisp.setText("0:0");
            time = 0;
            btReset.disable();
            btStart.enable();
            btStop.disable();
            btStart.setLabel("Start");
            return true;
        } else if (evt.target == btStop) {
            stop();
            btReset.enable();
            btStart.enable();
            btStop.disable();
            btStart.setLabel("Continue");
            return true;
        } else if (evt.target == btStart) {
            // Create and start the timer thread.
            timerThread = new Thread(this);
            timerThread.start();
            btReset.disable();
            btStart.disable();
            btStop.enable();
            btStart.setLabel("Continue");
            return true;
        }
        return false;
    }

    public void run() {
        while (timerThread == Thread.currentThread()) {
            timeDisp.setText("" + time/10 + ":" + time%10 + "0");
            time++;
            try { Thread.sleep(100); } catch (Exception e) {};
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
