import java.awt.*;
class Main extends Frame {
    String[] styleNames = {"plain", "italic", "bold", "bold-italic"};
    int[] styleValues = {Font.PLAIN, Font.ITALIC, Font.BOLD, 
                         Font.ITALIC|Font.BOLD};
    Choice chFont = new Choice();
    Choice chStyle = new Choice();
    TextField tf = new TextField("Hello");

    Main() {
        super("Choice Example");
        Panel p = new Panel();

        // Retrieve all the font names.
        for (int i=0; i<getToolkit().getFontList().length; i++) {
            chFont.addItem(getToolkit().getFontList()[i]);
        }
        // Initialize the font style choice.
        for (int i=0; i<styleNames.length; i++) {
            chStyle.addItem(styleNames[i]);
        }
        p.setLayout(new GridLayout(1, 0));
        p.add(chFont);
        p.add(chStyle);
        add("North", p);
        add("South", tf);
        resize(300, 150);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = insets();
        int w = size().width-insets.left-insets.right-2;
        int h = size().height-insets.top-insets.bottom-2;
        Font f = new Font(chFont.getSelectedItem(), 
            styleValues[chStyle.getSelectedIndex()], 24);
        FontMetrics fm = g.getFontMetrics(f);
        String str = tf.getText();

        g.clearRect(0, 0, w, h);
        g.setFont(f);
        g.drawString(str, (w-fm.stringWidth(str))/2, 
            (h-fm.getHeight())/2+fm.getAscent());
    }

    public boolean action(Event evt, Object arg) {
        repaint();
        return true;
    }

    static public void main(String[] args) {
        new Main();
    }
}
