import java.awt.*;
import java.io.*;
import java.util.*;

class Main extends Frame { 
    Color fg, originalFg;
    Color bg, originalBg;
    String str;

    Main() {
        super("getColor Example");
        try {
            System.getProperties().load(
                new FileInputStream("properties.txt"));
            System.getProperties().list(System.out);
            fg = originalFg = Color.getColor("text.fg", 0x000000);
            bg = originalBg = Color.getColor("text.bg", Color.white);
            str = System.getProperties().getProperty("text.value");
        } catch (Exception e) {
            e.printStackTrace();
        }
        resize(200, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = insets();
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;
        Font f = new Font("Helvetica", Font.BOLD, 40);
        FontMetrics fm = g.getFontMetrics(f);

        g.setFont(f);
        g.setColor(bg);
        g.fillRect(0, 0, w, h);
        g.setColor(fg);
        g.drawString(str, (w-fm.stringWidth(str))/2, 
                          (h-fm.getHeight())/2+fm.getAscent());
    }

    public boolean mouseDown(Event evt, int x, int y) {
        // If darkening or brightening either color has no
        // effect, simply swap the colors.
        if (originalFg.brighter().equals(originalFg)
            || originalBg.brighter().equals(originalBg)) {
            fg = originalBg;
            bg = originalFg;
        } else {
            fg = originalFg.brighter();
            bg = originalBg.darker();
        }
        repaint();
        return true;
    }

    public boolean mouseUp(Event evt, int x, int y) {
        fg = originalFg;
        bg = originalBg;
        repaint();
        return true;
    }

    public static void main(String[] args) {
        new Main();
    }
}
