import java.awt.*;
class Main {
    static public void main(String[] args) {
        Frame f = new Frame("createImage Example");
        f.add("Center", new MainCanvas());
        f.resize(200, 100);
        f.show();
    }
}

class MainCanvas extends Canvas implements Runnable {
    Image backBuffer;
    Graphics backG;
    String str = "Java";
    int pointSize = 15;
    Point[] points = new Point[10];
    int[] pointRates = new int[points.length];
    Point stringPt = new Point(0, 0);

    MainCanvas() {
        for (int i=0; i<points.length; i++) {
            points[i] = new Point(0, 0);
            initPoint(i);
        }
        (new Thread(this)).start();
    }

    void initPoint(int i) {
        points[i].x = (int)(Math.floor(Math.random()*size().width));
        points[i].y = size().height;
        pointRates[i] = (int)(Math.floor(Math.random()*30)) + 5;
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        int w = bounds().width;
        int h = bounds().height;

        if (backBuffer == null 
                || backBuffer.getWidth(null) != w
                || backBuffer.getHeight(null) != h) {
            backBuffer = createImage(w, h);
            if (backBuffer != null) {
                if (backG != null) {
                    backG.dispose();
                }
                backG = backBuffer.getGraphics();
                backG.setFont(new Font("Helvetica", Font.BOLD, 48));
                FontMetrics fm = backG.getFontMetrics();
                stringPt.x = (w-fm.stringWidth(str))/2; 
            }
        }

        if (backBuffer != null) {
            backG.setColor(new Color(130, 80, 80));  // brown
            backG.fillRect(0, 0, w, h);

            // Bubbles behind the string.
            backG.setColor(Color.white);
            for (int i=0; i<points.length/3; i++) {
                backG.fillOval(points[i].x, points[i].y, pointSize, pointSize);
            }

            // Paint the string
            backG.setColor(Color.black);
            backG.drawString(str, stringPt.x, stringPt.y % h + h);
            backG.drawString(str, stringPt.x, stringPt.y % h + 2*h);

            // Bubbles in front of the string.
            backG.setColor(Color.white);
            for (int i=points.length/3; i<points.length; i++) {
                backG.fillOval(points[i].x, points[i].y, pointSize, pointSize);
            }
            g.drawImage(backBuffer, 0, 0, null);
        }
    }

    public void run() {
        while (true) {
            for (int i=0; i<points.length; i++) {
                points[i].y -= pointRates[i];
                if (points[i].y < -pointSize) {
                    initPoint(i);
                }
            }
            stringPt.y--;
            repaint();
            try { Thread.sleep(80); } catch (Exception e) {};
        }
    }
}
