import java.awt.*;
class Main extends Frame {
    BlinkButton b = new BlinkButton("Blink");
    Main() {
        super("show Example");
        add("North", new Button("Show/Hide"));
        add("South", b);
        pack();
        show();
    }
    
    public boolean action(Event evt, Object arg) {
        if ("Show/Hide".equals(arg)) {
            if (b.isVisible()) {
                b.hide();
            } else {
                b.show();
                invalidate();
                validate();
            }
            // OR b.show(!b.isVisible());
            return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}

class BlinkButton extends Button implements Runnable {
    String label;

    BlinkButton(String label) {
        super(label);
        this.label = label;
    }

    public void addNotify() {
        super.addNotify();
        (new Thread(this)).start();
    }

    public synchronized void removeNotify() {
        super.removeNotify();
    }

    public void run() {
        boolean on = false;
        while (true) {
            synchronized (this) {
                if (getPeer() == null) {
                    break;
                }

                // Actually, isVisible() could have been used
                // instead of isShowing() since the previous 
                // statement guarantees that the button's peer exists.
                if (isShowing()) {
                    if (on) {
                        setLabel(label);
                    } else {
                        setLabel("");
                    }
                    on = !on;
                }
            }
            try {
                Thread.sleep(1000);
            } catch (Exception e) {
            }
        }
    }
}