import java.awt.*;
import java.io.*;
import java.util.*;

class Main extends Frame {
    StringBufferInputStream is = 
        new StringBufferInputStream("Hello\nWorld!\nHow are\nyou\ntoday?");
    int[] charWidths;

    Main() {
        super("getWidths Example");
        setFont(new Font("Helvetica", Font.PLAIN, 20));
        resize(300, 200);
        show();
    }

    public void paint(Graphics g) {
        int x = 0, y = 0;
        int ch;
        char[] chs = new char[1];
        FontMetrics fm = g.getFontMetrics();

        if (charWidths == null) {
            charWidths = fm.getWidths();
        }
        is.reset();
        while ((ch = is.read()) != -1) {
            if (ch == '\n') {
                x += fm.getMaxAdvance() + fm.getDescent();
                y = 0;
                continue;
            }
            chs[0] = (char)ch;
            g.drawChars(chs, 0, 1, 
                x + (fm.getMaxAdvance()-charWidths[ch])/2, 
                y + fm.getAscent());
            y += fm.getHeight();
        }
    }

    static public void main(String[] args) {
	new Main();
    }
}
