import java.awt.*;
class Main extends Frame {
    Panel panel = new Panel();

    MainCanvas cv = new MainCanvas();
    Canvas overlap = new Canvas();
    Checkbox cb = new Checkbox("Overlap", null, false);

    Main() {
        super("copyArea Example");
        panel.setLayout(new BorderLayout());
        panel.add("Center", cv);

        add(overlap);
        add(panel);
        add(cb);
        overlap.setBackground(Color.green);
        overlap.hide();
        resize(400, 100);
        show();
    }

    // In order to get the overlapping window to overlap another, 
    // we need to implement our own specific layout.  
    public synchronized void layout() {
        Insets insets = this.insets();
        Dimension d = cb.preferredSize();
        int w = size().width - insets.left-insets.right;
        int h = size().height - insets.top-insets.bottom;

        panel.reshape(insets.left, insets.top, w, h-d.height);
        cb.reshape(insets.left, size().height-insets.bottom-d.height, 
                   w, d.height);
        overlap.reshape(insets.left, insets.top, 1, h);
    }

    public boolean action(Event evt, Object what) {
        if (evt.target == cb) {
            overlap.show(cb.getState());
            return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas implements Runnable {
    MainCanvas() {
        (new Thread(this)).start();
    }

    //  Returns an integer in the range [0..r-1].
    int random(int r) {
        return (int)(Math.floor(Math.random()*r));
    }

    public void update(Graphics g) {
        int w = size().width;
        int h = size().height;

        // shift right by 1 pixel.
        g.copyArea(0, 0, w-1, h, 1, 0);
        g.clearRect(0, 0, 1, h);
        g.drawLine(0, random(h), 0, h);
    }

    public void paint(Graphics g) {
        int w = size().width;
        int h = size().height;
        Rectangle r = g.getClipRect();

        if (r == null || (r.width == w && r.height == h)) {
            g.setColor(Color.blue); // full repaint
        } else {
            g.setColor(Color.red); // partial repaint
        }
        g.fillRect(0, random(h), w, h);
    }

    public void run() {
        while (true) {
            try {Thread.sleep(100);} catch (Exception e) {};
            repaint();
        }
    }
}
