import java.awt.*;
import java.util.*;
class Main extends Frame {
    Vector points = new Vector();
    int lastDrawnPoint = 0;

    Main() {
        super("drawLine Example");
        resize(200, 200);
        show();
    }

    public void paint(Graphics g) {
        Point curPt = null;
        for (int i=0; i<points.size(); i++) {
            Point pt = (Point)points.elementAt(i);

            if (curPt != null) {
                g.drawLine(curPt.x, curPt.y, pt.x, pt.y);
            }
            curPt = pt;
        }
        lastDrawnPoint = points.size();
    }
    
    public void update(Graphics g) {
        Point curPt = null;
        lastDrawnPoint = Math.max(0, lastDrawnPoint-1);
        for (int i=lastDrawnPoint; i<points.size(); i++) {
            Point pt = (Point)points.elementAt(i);

            if (curPt != null) {
                g.drawLine(curPt.x, curPt.y, pt.x, pt.y);
            }
            curPt = pt;
        }
        lastDrawnPoint = points.size();
    }

    public boolean mouseDown(Event evt, int x, int y) {
        Point pt = new Point(x, y);
        points.addElement(pt);
        repaint();
        return true;
    }

    public boolean mouseDrag(Event evt, int x, int y) {
        Point pt = new Point(x, y);
        points.addElement(pt);
        repaint();
        return true;
    }

    static public void main(String[] args) {
        new Main();
    }
}
