import java.awt.*;
class Main extends Frame {
    MainCanvas cv = new MainCanvas();
    Choice c = new Choice();
    Main() {
        super("fillRoundRect Example");
        add("Center", cv);

        c.addItem("create/dispose");
        c.addItem("drawRect");
        c.addItem("drawRoundRect");
        c.addItem("fillRect");
        c.addItem("fillRoundRect");
        add("South", c);
        resize(200, 200);
        show();
    }

    public boolean action(Event evt, Object arg) {
        if (evt.target == c) {
            cv.operation = c.getSelectedIndex();
	    return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}
class MainCanvas extends Canvas implements Runnable {
    int operation;
    Thread timerThread;
    
    public void paint(Graphics g) {
        int w = size().width-1;
        int h = size().height-1;
        if (timerThread != null) {
            int count = 0;
            long startTime = System.currentTimeMillis();
    
            switch (operation) {
              case 0:
                while (timerThread != null) {
	            Graphics g2 = g.create();
                    g2.dispose();
                    count++;
                }
              case 1:
                while (timerThread != null) {
	            g.drawRect(0, 0, w, h);
                    count++;
                }
              case 2:
                while (timerThread != null) {
	            g.drawRoundRect(0, 0, w, h, 20, 20);
                    count++;
                }
              case 3:
                while (timerThread != null) {
	            g.fillRect(0, 0, w, h);
                    count++;
                }
              case 4:
                while (timerThread != null) {
	            g.fillRoundRect(0, 0, w, h, 20, 20);
                    count++;
                }
            }
            System.out.print((double)count*1000.0 
                / (double)(System.currentTimeMillis()-startTime));
            System.out.println(" paints/second");
        }
    }

    public void run() {
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
        }
        timerThread = null;
    }

    public boolean mouseDown(Event evt, int x, int y) {
        if (timerThread == null) {
            timerThread = new Thread(this);
            timerThread.start();
            repaint();
        }
        return true;
    }
}
