import java.awt.*;
public class Main extends Frame {
    GridBagLayout gbl = new GridBagLayout();
    Label l = new Label();

    Main() {
        super("location Example");
        Panel p = new Panel();
        p.setLayout(gbl);
        for (int i=0; i<2; i++) {
            for (int j=0; j<2; j++) {
                makeCanvas(p, "("+i+","+j+")", i, j);
            }
        }
        add("Center", p);
        add("South", l);
        pack();
        show();
    }

    public boolean mouseMove(Event evt, int x, int y) {
        Insets insets = this.insets();
        Point p = gbl.location(x-insets.left, y-insets.top);

        l.setText("("+p.x+", "+p.y+")");
        return true;
    }

    void makeCanvas(Container cont, String label, int x, int y) {
        GridBagConstraints c = new GridBagConstraints();
        MainCanvas cv = new MainCanvas(label);

        cont.add(cv);
        cv.resize(25, 25);
        c.gridx = x;
        c.gridy = y;
        gbl.setConstraints(cv, c);
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    String label;

    MainCanvas(String label) {
        this.label = label;
    }

    public void paint(Graphics g) {
        int w = size().width;
        int h = size().height;
        FontMetrics fm = g.getFontMetrics();

        g.drawString(label, (w-fm.stringWidth(label))/2, 
            (h-fm.getHeight())/2+fm.getAscent());
        g.setColor(getBackground());
        g.draw3DRect(0, 0, w-1, h-1, false);
    }
}
