import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.IOException;

class Anchor {
    // writes out an HTML anchor:    <A HREF="ref"> desc </A>
    public static void anchor(String[] desc, String[] ref, OutputStream out)
    throws IOException{
        ByteArrayOutputStream buf = new ByteArrayOutputStream();
        byte[] prefix = {'<', 'A', ' ', 'H', 'R', 'E', 'F', '=', '"'};
        byte[] suffix = {' ', '<', '/', 'A', '>'};

        for (int a = 0; a < desc.length; a++) {
                buf.write(prefix, 0, prefix.length);
                for (int i = 0; i < ref[a].length(); i++)
                        buf.write((int)ref[a].charAt(i));

                buf.write('"');
                buf.write('>');
                buf.write(' ');
                for (int i = 0; i < desc[a].length(); i++)
                        buf.write((int)desc[a].charAt(i));

                buf.write(suffix, 0, suffix.length);
                buf.write('\n');
                buf.writeTo(out);
                buf.reset();        // reset stream to start of buffer
        }
    }
    public static void main(String[] args) {
        String[] desc = {"Preface", "Table of Contents",
                         "Index", "Glossary"};
        String[] ref = {"preface.htm", "toc.htm", 
                        "index.htm", "glossary.htm"};
        try {
            anchor(desc, ref, System.out);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
