import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

class Skip {
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: java Skip <input_file>");
            System.exit(-1);
        }
        try {
            FileInputStream in = new FileInputStream(args[0]);
            // create reference to same file
            FileInputStream in2 = new FileInputStream(in.getFD());
            int avail = in2.available();        // size of file

            System.out.print(args[0] + ": " + avail + " bytes");

            // skip to end of file
            System.out.println("; skipped " + in2.skip(avail) + " bytes");

            // should have nothing left in file for reading
            int c;
            while ((c=in.read()) > -1)
                System.out.print((char)c);
            
            in2.close();        // closes both in2 and in
            System.out.flush();
        } catch (FileNotFoundException e) {
            System.err.println(args[0] + " is not found");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
