import java.awt.*;
class Main extends Frame {
    Label loLabel = new Label();
    Label hiLabel = new Label();
    ThreadGroup hiGroup = new ThreadGroup("High");
    ThreadGroup loGroup = new ThreadGroup("Low");
    
    Main() {
        super("suspend Example");

        // Limit the priority in the lo priority thread group.
        loGroup.setMaxPriority(Thread.MIN_PRIORITY);

        // Add a few threads.
        (new Worker(hiGroup, hiLabel)).start();
        (new Worker(hiGroup, hiLabel)).start();
        (new Worker(loGroup, loLabel)).start();
        (new Worker(loGroup, loLabel)).start();

        add("North", hiLabel);
        add("South", loLabel);
        add("Center", new Button("suspend"));
        pack();
        show();
    }

    public synchronized boolean handleEvent(Event evt) {
        if ("suspend".equals(evt.arg)) {
            hiGroup.suspend();
            ((Button)evt.target).setLabel("resume");
            return true;
        } else if ("resume".equals(evt.arg)) {
            hiGroup.resume();
            ((Button)evt.target).setLabel("suspend");
            return true;
        }
        return false;
    }


    static public void main(String[] args) {
        new Main();
    }
}

class Worker extends Thread {
    Label label;

    Worker(ThreadGroup group, Label label) {
        super(group, "Worker");
        this.label = label;
    }

    public void run() {
        try {
            for (int i=0; ; i++) {
                if (i % 10 == 0) {
                    label.setText(""+i);
                }
                Thread.sleep(16);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
