import java.net.*;
import java.io.*;
import java.util.Date;

public class DateURLConnection extends URLConnection {
    DatagramSocket sock = null;
    public DateURLConnection(URL u) {
        super(u);
    }
    public void connect() throws IOException {
        InetAddress dst = InetAddress.getByName(getURL().getHost());
        byte[] outbuf = new byte[1];
        outbuf[0] = '\n';
        int port;
        if ((port = getURL().getPort()) == -1)
            port = 13;        // daytime

        DatagramPacket request = 
            new DatagramPacket(outbuf, outbuf.length, dst, port);
        try {
            sock = new DatagramSocket();
            sock.send(request);
            connected = true;
        } catch (SocketException e) {
            sock = null;
            throw e;
        }
    }
    public Object getContent() throws IOException {
        if (!connected)
            connect();

        byte[] inbuf = new byte[256];  // default size
        DatagramPacket reply = 
            new DatagramPacket(inbuf, inbuf.length);
        sock.receive(reply);
        sock.close();
        sock = null;
        connected = false;
        String dateStr = new String(reply.getData(), 0);
        if (dateStr != null)
            return (new Date(dateStr));

        return (null);
    }
}
